#include "frame.h"
#include "ftdicomms.h"

#define LED_G0 (1<<0)
#define LED_R0 (1<<1)
#define LED_R1 (1<<2)
#define LED_G1 (1<<3)
#define LED_R2 (1<<4)
#define LED_G2 (1<<5)
#define LED_STROBE (1<<6)

#define LED_A0 (1<<9)
#define LED_A1 (1<<10)
#define LED_A2 (1<<11)
#define LED_A3 (1<<12)
#define LED_RENA (1<<13)
#define LED_GENA (1<<14)

#define FRAMEW 224

#if 1
#define PIXELR(map, x, y) map[(((x)+((y)*FRAMEW))*3)]
#define PIXELG(map, x, y) map[(((x)+((y)*FRAMEW))*3)+1]
#define PIXELB(map, x, y) map[(((x)+((y)*FRAMEW))*3)+2]
#else
#define PIXELR(map, x, y) (((x^y)&1)?255:0)
#define PIXELG(map, x, y) (((x^y)&2)?255:0)
#define PIXELB(map, x, y) (((x^y)&4)?255:0)
#endif


#define GRAYINC 16
#define GRAYSPREADX 128
#define GRAYSPREADY 64
void frameSend(unsigned char *pixmap) {
	int x,y,b,lb,oldy=15;
	static unsigned char fcnt=0;
	unsigned char lcnt, pcnt, ppcnt;
	fcnt+=GRAYINC;//+GRAYSPREAD;
	lcnt=fcnt;
	for (y=0; y<16; y++) {
		lcnt+=GRAYINC+GRAYSPREADX;
		lb=0;
		if (oldy&1) lb|=LED_A0;
		if (oldy&2) lb|=LED_A1;
		if (oldy&4) lb|=LED_A2;
		if (oldy&8) lb|=LED_A3;
		ppcnt=lcnt;
		for (x=0; x<FRAMEW; x++) {
			ppcnt+=GRAYSPREADY+GRAYINC;//+rand();
			pcnt=ppcnt;
			if ((x+y)&1) pcnt+=8;
			b=lb;
			if (x==FRAMEW-1) b|=LED_STROBE;
//			pcnt=127;
			if (PIXELR(pixmap, x, y)>pcnt) b|=LED_R0;
			if (PIXELG(pixmap, x, y)>pcnt) b|=LED_G0;
			if (PIXELR(pixmap, x, y+16)>pcnt) b|=LED_R1;
			if (PIXELG(pixmap, x, y+16)>pcnt) b|=LED_G1;
			if (PIXELR(pixmap, x, y+32)>pcnt) b|=LED_R2;
			if (PIXELG(pixmap, x, y+32)>pcnt) b|=LED_G2;
			if (y==15 && x==FRAMEW-1) {
				b|=LED_RENA+LED_GENA;
				ftdiWriteWord(b);
			} else {
				if (x==0) {
					ftdiWriteWord(b);
				} else {
					ftdiWritePixels(b);
				}
			}
		}
		oldy=y;
	}
	if (fcnt==0) ftdiFlush();
//	printf("Frame %i n=%i\n",no++, n);
}